---
  - name: "(Setup: RedHat/CentOS) Upgrade all packages to the latest version"
    yum:
      name: '*'
      state: latest
    when: ansible_distribution == 'CentOS' or ansible_distribution == 'Red Hat Enterprise Linux'

  - name: "(Setup: Debian/Ubuntu) Upgrade all packages to the latest version"
    apt:
      name: "*"
      state: latest
    when: ansible_distribution == 'Debian' or ansible_distribution == 'Ubuntu'

  - name: "(Setup: RedHat/CentOS) Allow access to webserver through OS firewall"
    firewalld:
      service: "{{ item.service }}"
      permanent: "{{ item.permanent }}"
      state: "{{ item.state }}"
      immediate: "{{ item.immediate }}"
    notify:
      - restart firewalld
    when: ansible_distribution == 'CentOS' or ansible_distribution == 'Red Hat Enterprise Linux'
    loop:
      - { service: 'http', permanent: 'yes', state: 'enabled', immediate: 'yes' }
      - { service: 'https', permanent: 'yes', state: 'enabled', immediate: 'yes' }

  - name: "(Setup: Debian/Ubuntu) Allow access to webserver through OS firewall"
    ufw:
      port: "{{ item.port }}"
      rule: "{{ item.rule }}"
      proto: "{{ item.proto }}"
    notify:
      - reload ufw
    when: ansible_distribution == 'Debian' or ansible_distribution == 'Ubuntu'
    with_items:
      - { rule: 'limit', port: '{{ ssh_port | default("22") }}', proto: 'tcp' }
      - { rule: 'allow', port: '80', proto: 'tcp' }
      - { rule: 'allow', port: '443', proto: 'tcp' }

  - name: "(Setup: All OSs) Get all files in webserver root"
    find:
      paths: /usr/share/nginx/html
      patterns: '*.html'
    register: files_to_delete

  - name: "(Setup: All OSs) Delete all files in webserver root"
    file:
      path: "{{ item.path }}"
      state: absent
    with_items: "{{ files_to_delete.files }}"
